<template>
  <ele-modal
    :visible.sync="visible"
    v-if="visible"
    :closed="cancel"
    :title="`${type == 'add' ? '创建' : '编辑'}下料计划`"
    custom-class="ele-dialog-form"
    :close-on-click-modal="true"
    :close-on-press-escape="false"
    width="80%"
    :maxable="true"
  >
    <el-form
      :model="formData"
      ref="formRef"
      label-width="120px"
      class="ele-body"
      :rules="rules"
    >
      <el-row :gutter="24">
        <el-col :span="8">
          <el-form-item label="需求类型" prop="demandType">
            <el-select
              v-model="formData.demandType"
              placeholder="请选择"
              style="width: 100%"
              :disabled="type == 'detail'"
              @change="changType"
            >
              <el-option
                v-for="item in demandTypeList"
                :key="item.dictCode"
                :label="item.dictValue"
                :value="item.dictCode"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="计划名称" prop="name">
            <el-input
              placeholder="请选择"
              v-model="formData.name"
              :readonly="type == 'detail'"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="8">
          <el-form-item label="备注" prop="remark">
            <el-input
              placeholder="备注"
              v-model="formData.remark"
              :readonly="type == 'detail'"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>

    <el-form :model="formData" ref="tableForm">
      <ele-pro-table
        ref="table"
        :needPage="false"
        :columns="columns"
        row-key="id"
        :expanded-row-keys="expandedRowKeys"
      >
        <template v-slot:toolbar>
          <el-button
            size="small"
            type="primary"
            icon="el-icon-plus"
            class="ele-btn-icon"
            @click="saleAdd"
            v-if="type != 'detail'"
          >
            添加销售订单
          </el-button>
        </template>

        <template v-slot:code="{ row }">
          <el-input
            placeholder="请输入"
            readonly
            :value="row.code || row.salesOrderCode"
          ></el-input>
        </template>

        <template v-slot:productionPlanId="{ row }">
          <el-link
            type="primary"
            v-if="!row.productionPlanId"
            :underline="false"
            @click.native="openVersion(row)"
            :disabled="type == 'detail'"
            >选择</el-link
          >
        </template>

        <template v-slot:action="{ row, $index }" v-if="type != 'detail'">
          <template>
            <el-link
              type="primary"
              :underline="false"
              @click="categorySelect(row)"
            >
              添加物料
            </el-link>
            <el-popconfirm
              class="ele-action"
              title="确定要删除此销售订单吗？"
              @confirm="remove(row, $index)"
            >
              <template v-slot:reference>
                <el-link type="danger" :underline="false" icon="el-icon-delete">
                  删除
                </el-link>
              </template>
            </el-popconfirm>
          </template>
        </template>

        <!-- 展开内容 -->
        <template v-slot:expand="{ row, $index }">
          <div
            style="
              width: calc(100% - 95px);
              min-height: 60px;
              margin-left: 95px;
            "
            v-if="row.materialList.length > 0"
          >
            <ele-pro-table
              :toolbar="false"
              toolsTheme="none"
              ref="table2"
              :need-page="false"
              :datasource="row.materialList"
              :columns="columns2"
              :key="row.categoryId + '-' + $index"
            >
              <template v-slot:sort="{ $index }">
                {{ $index + 1 }}
              </template>

              <template v-slot:unit="{ row }">
                {{ row.unit }}
              </template>

              <template v-slot:demandQuantity="{ row }">
                <el-input
                  v-model="row.demandQuantity"
                  placeholder="请输入"
                  :readonly="type == 'detail'"
                  @input="
                    (value) =>
                      (row.demandQuantity = value.replace(
                        /^(-)*(\d+)\.(\d\d\d\d\d\d).*$/,
                        '$1$2.$3'
                      ))
                  "
                ></el-input>
              </template>

              <template v-slot:purchasingCycle="{ row }">
                {{ row.purchasingCycle }}{{ row.purchasingCycleUnit }}
              </template>

              <template v-slot:purchaseQuantity="{ row }">
                <el-input
                  v-model="row.purchaseQuantity"
                  placeholder="请输入"
                  :readonly="type == 'detail'"
                  @input="
                    (value) =>
                      (row.purchaseQuantity = value.replace(
                        /^(-)*(\d+)\.(\d\d\d\d\d\d).*$/,
                        '$1$2.$3'
                      ))
                  "
                ></el-input>
              </template>

              <template v-slot:deliveryMethod="{ row }">
                <el-select
                  clearable
                  class="ele-block"
                  v-model="row.deliveryMethod"
                  placeholder="请选择"
                  :disabled="type == 'detail'"
                >
                  <el-option
                    label="一次性到货"
                    :value="1"
                    @click.native="row.timeList = null"
                  />
                  <el-option
                    label="分批到货"
                    :value="2"
                    @click.native="
                      handleMethod(row);
                      row.requireDeliveryTime = null;
                    "
                  />
                </el-select>
              </template>

              <template v-slot:requireDeliveryTime="{ row }">
                <el-date-picker
                  style="width: 100%"
                  clearable
                  v-model="row.requireDeliveryTime"
                  type="date"
                  v-show="row.deliveryMethod == 1"
                  value-format="yyyy-MM-dd"
                  placeholder="请选择日期"
                  :readonly="type == 'detail'"
                  :pickerOptions="{
                    disabledDate: (time) =>
                      time.getTime() <
                      new Date(new Date().setHours(0, 0, 0, 0)).getTime()
                  }"
                >
                </el-date-picker>

                <el-link
                  type="primary"
                  :underline="false"
                  v-show="row.deliveryMethod == 2"
                  @click.native="handleMethod(row)"
                >
                  设置分批时间
                </el-link>
              </template>

              <template v-slot:imgUrl="{ row }">
                <fileMain
                  v-model="row.imgUrl"
                  module="main"
                  :showLib="false"
                  :limit="1"
                  :disabled="type == 'detail'"
                />
              </template>

              <template v-slot:files="{ row }">
                <fileMain
                  v-model="row.files"
                  module="main"
                  :showLib="false"
                  :limit="1"
                  :disabled="type == 'detail'"
                />
              </template>

              <template v-slot:action="{ row }" v-if="type != 'detail'">
                <el-popconfirm
                  class="ele-action"
                  title="确定要删除当前物料吗？"
                  @confirm="remove2(row)"
                >
                  <template v-slot:reference>
                    <el-link
                      type="danger"
                      :underline="false"
                      icon="el-icon-delete"
                    >
                      删除
                    </el-link>
                  </template>
                </el-popconfirm>
              </template>
            </ele-pro-table>
          </div>
        </template>
      </ele-pro-table>
    </el-form>

    <div slot="footer" v-if="type != 'detail'">
      <el-button @click="cancel">取消</el-button>
      <el-button type="primary" @click="confirm">保存</el-button>
    </div>

    <saleOrderPop ref="saleOrderRef" @chooseOrder="chooseOrder"></saleOrderPop>

    <ProductModal ref="productRefs" @chooseModal="chooseModal" />

    <ProductionVersion
      ref="versionRefs"
      @changeProduct="changeProduct"
    ></ProductionVersion>

    <timeDialog ref="timeDialogRef" @chooseTime="chooseTime"></timeDialog>
  </ele-modal>
</template>

<script>
  import saleOrderPop from '@/views/materialPlan/components/saleOrderPop.vue';
  import ProductModal from '@/views/materialPlan/components/ProductModal.vue';

  import {
    baitingListBomBySalesOrderIds,
    listBomBySalesOrderId,
    save,
    getById
  } from '@/api/cuttingPlan/index';
  import ProductionVersion from '@/components/CreatePlan/ProductionVersion2.vue';
  // import fileUpload from '@/components/addDoc/index.vue';
  import timeDialog from './timeDialog';
  import dictMixins from '@/mixins/dictMixins';
  export default {
    components: {
      saleOrderPop,
      ProductModal,
      ProductionVersion,
      // fileUpload,
      timeDialog
    },
    mixins: [dictMixins],
    data() {
      return {
        visible: false,
        type: 'add',

        tableData: [],

        xsId: null,

        formData: {
          name: '',
          remark: '',
          detailRemoveIds: [],
          materialRemoveIds: [],
          orderType: 1,
          demandType: ''
        },
        demandTypeList: [
          {
            dictCode: '1',
            dictValue: '生产性物资采购'
          },
          {
            dictCode: '6',
            dictValue: '外协自供料采购'
          },
          {
            dictCode: '7',
            dictValue: '外协客供料采购'
          }
        ],
        expandedRowKeys: [],
        rules: {
          demandType: [
            {
              required: true,
              message: '请选择需求类型',
              trigger: ['blur', 'change']
            }
          ],

          name: [
            {
              required: true,
              message: '请输入配料计划名称',
              trigger: ['blur', 'change']
            }
          ]
        }
      };
    },
    computed: {
      // 表格列配置
      columns() {
        const list = [
          {
            width: 45,
            type: 'expand',
            columnKey: 'materialList',
            align: 'center',
            slot: 'expand'
          },

          {
            width: 50,
            label: '序号',
            type: 'index',
            align: 'center',
            slot: 'index'
          },
          {
            prop: 'purchaseType',
            label: '采购类型',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 120,
            sortable: true,
            formatter: (row) => {
              return row.purchaseType == '1' ? '未采购' : '已采购';
            }
          },
          {
            prop: 'code',
            label: '销售订单号',
            slot: 'code',
            showOverflowTooltip: true,
            align: 'center',
            minWidth: 170,
            sortable: true
          },
          {
            prop: 'customerName',
            label: '客户名称',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'deliveryNum',
            label: '客户代号',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'productCode',
            label: '编码',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 140
          },

          {
            prop: 'productName',
            label: '名称',
            align: 'center',
            minWidth: 120
          },

          {
            prop: 'model',
            label: '型号',
            align: 'center',
            minWidth: 120
          },

          {
            prop: 'brandNo',
            label: '牌号',
            align: 'center'
          },

          {
            prop: 'deliveryTime',
            label: '交付日期',
            align: 'center',
            showOverflowTooltip: true
          },
          {
            prop: 'contractNum',
            label: '订单数量',
            align: 'center'
          },
          {
            prop: 'lackNum',
            label: '欠交数量',
            align: 'center'
          },

          {
            prop: 'productionPlanId',
            label: '工艺路线',
            slot: 'productionPlanId',
            align: 'center',
            minWidth: 110
          },

          this.type != 'detail'
            ? {
                columnKey: 'action',
                label: '操作',
                width: 150,
                align: 'center',
                resizable: false,
                slot: 'action',
                showOverflowTooltip: true
              }
            : ''
        ].filter(Boolean);
        return list;
      },
      columns2() {
        const list = [
          {
            width: 50,
            label: '序号',
            prop: 'sort',
            slot: 'sort',
            align: 'center'
          },

          {
            label: '物料名称',
            prop: 'name',
            align: 'center',
            minWidth: 120
          },

          {
            label: '物料编码',
            prop: 'code',
            align: 'center',
            minWidth: 120
          },
          {
            label: '牌号',
            prop: 'brandNum',
            align: 'center'
          },
          {
            prop: 'specification',
            label: '规格',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 110
          },
          {
            label: '型号',
            prop: 'modelType',
            align: 'center'
          },

          {
            prop: 'inventoryQuantity',
            label: '库存',
            showOverflowTooltip: true
          },

          {
            prop: 'unit',
            label: '计量单位',
            showOverflowTooltip: true,
            action: 'unit',
            slot: 'unit'
          },

          {
            label: '需求数量',
            slot: 'demandQuantity',
            action: 'demandQuantity',
            align: 'center',
            minWidth: 120
          },

          {
            label: '采购数量',
            slot: 'purchaseQuantity',
            action: 'purchaseQuantity',
            align: 'center',
            minWidth: 120
          },
          {
            label: '采购周期',
            action: 'purchasingCycle',
            align: 'center',
            minWidth: 160
          },
          {
            label: '到货方式',
            slot: 'deliveryMethod',
            action: 'deliveryMethod',
            align: 'center',
            minWidth: 140
          },

          {
            label: '要求到货时间',
            slot: 'requireDeliveryTime',
            action: 'requireDeliveryTime',
            align: 'center',
            minWidth: 180
          },

          {
            label: '图纸',
            slot: 'imgUrl',
            action: ' imgUrl',
            align: 'center',
            minWidth: 140
          },

          {
            label: '附件',
            slot: 'files',
            action: ' files',
            align: 'center',
            minWidth: 140
          },

          this.type != 'detail'
            ? {
                columnKey: 'action',
                label: '操作',
                width: 70,
                align: 'center',
                resizable: false,
                slot: 'action',
                showOverflowTooltip: true
              }
            : ''
        ].filter(Boolean);
        return list;
      }
    },
    created() {},

    methods: {
      async open(type, row) {
        this.type = type;
        if (type == 'add') {
          this.formData = {
            name: '',
            remark: '',
            detailRemoveIds: [],
            materialRemoveIds: [],
            orderType: 1,
            demandType: ''
          };
        }

        console.log(this.formData, 'this.formData');
        this.visible = true;
        this.formData.orderType = 1;
        if (row) {
          this.getDetail(row.id);
        } else {
          this.$nextTick(() => {
            this.$refs.table.setData([]);
          });
        }
      },

      changType(val) {
        console.log(val);
        this.$set(this.formData, 'demandType', val);
      },

      getDetail(id) {
        getById(id).then((res) => {
          this.$set(this.formData, 'demandType', res.demandType);
          this.$set(this.formData, 'name', res.name);
          this.$set(this.formData, 'remark', res.remark);
          this.formData['id'] = res.id;
          if (res.salesOrderList) {
            this.$refs.table.setData([...res.salesOrderList]);
            // 展开所有行
            this.expandedRowKeys = this.$refs.table
              .getData()
              ?.map((item) => item.id);
          }

          this.$nextTick(() => {
            this.$refs.table.toggleRowExpansionAll();
            this.$forceUpdate();
          });
        });
      },

      confirm() {
        this.$refs.formRef.validate(async (value) => {
          if (value) {
            let _arr = this.$refs.table.getData() ?? [];

            if (_arr.length == 0) {
              this.$message.info('请添加销售订单');
              return false;
            }
            const salesOrderList = _arr.map((item) => {
              if (
                !Object.prototype.hasOwnProperty.call(item, 'salesOrderId') ||
                !item.salesOrderId
              ) {
                item.salesOrderId = item.id;
                item.salesOrderCode = item.code;
                delete item.id;
                delete item.code;
              }
              return item;
            });
            this.formData.type = 1;
            this.formData.baitingType = 1;
            this.formData.salesOrderList = salesOrderList;
            await save(this.formData);
            this.$message.success('保存成功！');
            this.$emit('success');
            this.cancel();
          }
        });
      },
      cancel() {
        this.visible = false;
        this.formData = {};
        this.formData.detailRemoveIds = [];
        this.formData.materialRemoveIds = [];
        this.$refs.table.setData([]);
        this.$refs.formRef.resetFields();
      },

      datasource({}) {
        return [];
      },

      reload() {
        this.$refs.table.reload();
      },

      saleAdd() {
        this.tableData = this.$refs.table.getData();

        this.$refs.saleOrderRef.open(this.tableData);
      },

      produceAdd() {},

      chooseOrder(list) {
        let salesOrderIds = [];
        list.map((m) => {
          salesOrderIds.push(m.id);
          return {
            ...m
          };
        });

        if (salesOrderIds.length > 0) {
          baitingListBomBySalesOrderIds({ salesOrderIds: salesOrderIds }).then(
            (res) => {
              res.forEach((m) => {
                if (m.materialList.length > 0) {
                  m.materialList.forEach((p) => {
                    p.detailId = m.id;
                  });
                }
              });

              this.$refs.table.setData([...this.tableData, ...res]);

              this.$nextTick(() => {
                this.$refs.table.toggleRowExpansionAll();
                this.$forceUpdate();
              });
            }
          );
        }
      },

      remove(row, index) {
        this.formData.detailRemoveIds.push(row.id);
        let _arr = this.$refs.table.getData() || [];
        _arr.splice(index, 1);
        this.$refs.table.setData([..._arr]);
      },
      categorySelect(row) {
        this.$refs.productRefs.open(row.materialList, row, this.type);
      },
      chooseModal(data, current) {
        data.map((m) => {
          m.detailId = current.id;
          // if (this.type == 'edit') {
          //   m.id = m.categoryId;
          // } else {
          //   m.id = '';
          // }
          delete m.id;
          return {
            ...m
          };
        });

        let tableList = [];
        tableList = this.$refs.table.getData();

        tableList.forEach((e) => {
          if (e.id == current.id) {
            if (e.materialList.length == 0) {
              e.materialList = data;
            } else {
              e.materialList = [...e.materialList, ...data];
            }
          }
        });

        console.log(tableList);
        this.$refs.table.setData([...tableList]);
        this.$forceUpdate();
      },

      remove2(row) {
        const data = this.$refs.table.getData() ?? [];
        this.formData.materialRemoveIds.push(row.categoryId);
        data.forEach((e) => {
          if (row.detailId == e.id) {
            e.materialList = e.materialList.filter(
              (d) => d.categoryId !== row.categoryId
            );
          }
        });

        this.$refs.table.setData([...data]);
        this.$forceUpdate();
      },

      openVersion(row) {
        this.xsId = row.id;
        this.$refs.versionRefs.open();
      },
      changeProduct(data) {
        let param = {
          salesOrderIds: [this.xsId],
          produceRoutingId: data.id
        };

        listBomBySalesOrderId(param).then((res) => {
          if (!res) return;

          const tableList = this.$refs.table.getData();

          tableList
            .forEach((e) => {
              if (e.id == this.xsId) {
                e.materialList = res.map((m) => {
                  m.detailId = this.xsId;
                  return {
                    ...m
                  };
                });

                this.$nextTick(() => {
                  this.$refs.table.setData([...tableList]);
                  this.$refs.table.toggleRowExpansionAll();
                });
              }
            })
            .catch((error) => {
              console.error('Failed to change product:', error);
            });
        });
      },

      handleMethod(row) {
        this.$refs.timeDialogRef.open(row);
      },
      chooseTime(current, timeList) {
        let tableList = [];
        tableList = this.$refs.table.getData();

        tableList.forEach((e) => {
          if (e.id == current.detailId) {
            e.materialList.forEach((m) => {
              if (m.categoryId == current.categoryId) {
                m.timeList = timeList || [];
              }
            });
          }
        });

        this.$refs.table.setData([...tableList]);
        this.$forceUpdate();
      }
    }
  };
</script>

<style lang="scss" scoped>
  :deep(.el-table__expanded-cell) {
    padding-bottom: 30px !important;
    border-bottom: 12px solid #ccffcc !important;
  }
</style>
